HELOWARS = {}
-- dofile("D:\\Dev\\Missions\\Helo_Wars.lua")
HELOWARS.RadioMenuF10 = MENU_MISSION:New("Helo Wars")

----------Zones

TestZone = { ZONE:New( "Test Zone" ) }

RomeZone1 = { ZONE:New( "Rome Zone 1" )}

DhafraZone1 = { ZONE:New( "Al Dhafra 1" ), ZONE:New( "Al Dhafra 2" ) }
DhafraZone2 = { ZONE:New( "Al Dhafra 3" ), ZONE:New( "Al Dhafra 4" ) }
DhafraZone3 = { ZONE:New( "Al Dhafra 1" ), ZONE:New( "Al Dhafra 2" ),ZONE:New( "Al Dhafra 3" ) ,ZONE:New( "Al Dhafra 4" )  }

AlBateenZone1 = { ZONE:New( "Al Bateen 1" ), ZONE:New( "Al Bateen 2" ) }

SasAlNakheelZone1 = { ZONE:New( "Sas Al Nakheel 1" ), ZONE:New( "Sas Al Nakheel 2" ) }

AbuDhabiZone1 = { ZONE:New( "Abu Dhabi 1" ), ZONE:New( "Abu Dhabi 2" ), ZONE:New( "Abu Dhabi 3" ) }

CoastalZone1 = { ZONE:New("Coastal Zone 1") }
CoastalZone2 = { ZONE:New("Coastal Zone 2") }

----------Templates

SoldierTemplates = { "Insurgent Soldier", "Insurgent RPG" }

AAATemplates = { "Insurgent AAA", "Insurgent AAA 2", "Insurgent AAA 3" ,"Insurgent AAA 4"}

CarTemplates = { "Insurgent Car", "Insurgent Car 2" }

SAMTemplates = { "Insurgent SAM", "Insurgent SAM 2" }

APCTemplates = { "Insurgent APC", "Insurgent APC 2" }

MBTTemplates = { "Insurgent MBT", "Insurgent MBT 2" }

ConvoyTemplates = { "Insurgent Convoy 1","Insurgent Convoy 2","Insurgent Convoy 3","Insurgent Convoy 4"}

BoatTemplates = { "Insurgent Boat", "Insurgent Boat 2"}

----------RED Units



local function getRandomPointFromZones(SomeZones)

  local tableSize = 0
  for idx,value in pairs(SomeZones) do tableSize = tableSize +1 end

  local selectedIndex = math.random(1,tableSize)
  return SomeZones[selectedIndex]:GetRandomPointVec3()
end

HeliTrucks = SPAWN:New( "Repair Truck" )

InsurgentBoats = SPAWN:New("Insurgent Boat"):InitRandomizeTemplate(BoatTemplates)

Soldier_1 = SPAWN:New( "Insurgent Soldier" )
Soldier_2 = SPAWN:New( "Insurgent RPG" )
Soldier_3 = SPAWN:New( "Insurgent Soldier" )
  :InitRandomizeTemplate( SoldierTemplates )


Car_1 = SPAWN:New( "Insurgent Car" )
  :InitRandomizeTemplate( CarTemplates )
  :OnSpawnGroup(
    function(SpawnGroup)

      local landingHandler = EVENTHANDLER:New()
      landingHandler:HandleEvent(EVENTS.Land)

      function landingHandler:OnEventLand(EventData)
        if EventData.IniUnit:IsClient() and SpawnGroup:GetFirstUnitAlive():IsDetected(EventData.IniUnit) then
          local clientPosition = EventData.IniUnit:GetCoordinate()
          local route = SpawnGroup:RouteGroundTo(clientPosition,50,"Line",1,
          function (controlledGroup,wpNumber,totalWP,params)

            TargetGroupName = params["GroupName"]
            TargetGroup = GROUP:FindByName(TargetGroupName)

            if wpNumber == 2 then
              boom = USERSOUND:New("kamikaze.ogg")
              boom:ToGroup(TargetGroup,0)
              SpawnGroup:GetFirstUnitAlive():Explode(3000,2)
            end
          end

          ,{EventData.IniGroup})

        end
      end
    end
  )

AAA_1 = SPAWN:New( "Insurgent AAA" )
  :InitRandomizeTemplate( AAATemplates )

APC_1 = SPAWN:New( "Insurgent APC" )
  :InitRandomizeTemplate( APCTemplates )

MBT_1 = SPAWN:New( "Insurgent MBT" )
  :InitRandomizeTemplate( MBTTemplates )  

SAM_1 = SPAWN:New( "Insurgent SAM" )
  :InitRandomizeTemplate( SAMTemplates )


CONVOY_TYPES = { SPAWN:New("Insurgent Convoy 1") , SPAWN:New("Insurgent Convoy 2") , SPAWN:New("Insurgent Convoy 3") , SPAWN:New("Insurgent Convoy 4")}
ConvoysSpawned = false

----Special Units

HELOWARS.ACE_1 = SPAWN:New( "Ace1" )  


----Test Spawns

function HELOWARS:testSpawns(onlySmoke)
  if not onlySmoke then
    Car_1:InitRandomizeZones( TestZone ):InitHeading(0, 360):Spawn()
  end
end


function HELOWARS:RequestSEAD()
  if Blue_SEAD_GROUP then
    if GMFunc.SEAD_Zone then
      HELOWARS.Blue_SEAD:ReSpawn(HELOWARS.Blue_SEAD:GetSpawnIndexFromGroup(Blue_SEAD_GROUP))
    else
      trigger.action.outText( "SEAD Target NOT Set", 10 )
      trigger.action.setUserFlag('12',0)
      trigger.action.setUserFlag('2',0)
    end
  else
    if GMFunc.SEAD_Zone then
      Blue_SEAD_GROUP = HELOWARS.Blue_SEAD:Spawn()
    else
      trigger.action.outText( "SEAD Target NOT Set", 10 )
      trigger.action.setUserFlag('12',0)
      trigger.action.setUserFlag('2',0)
    end
  end
end


function HELOWARS:RequestCAS()
  if Blue_CAS_GROUP then
    if GMFunc.CAS_Zone then
      HELOWARS.Blue_CAS:ReSpawn(HELOWARS.Blue_CAS:GetSpawnIndexFromGroup(Blue_CAS_GROUP))
    else
      trigger.action.outText( "CAS Target NOT Set", 10 )
      trigger.action.setUserFlag('13',0)
      trigger.action.setUserFlag('3',0)
    end
  else
    if GMFunc.CAS_Zone then
      Blue_CAS_GROUP = HELOWARS.Blue_CAS:Spawn()
    else
      trigger.action.outText( "CAS Target NOT Set", 10 )
      trigger.action.setUserFlag('13',0)
      trigger.action.setUserFlag('3',0)
    end
  end
end


----Open Slots at Dhafra and enable retaliation

function HELOWARS:LiberateDhafra()

  trigger.action.outText( "Al Dhafra has been captured by allied forces", 10 )

  -- Toggle slot availability

  trigger.action.setUserFlag("helicargo9",0)
  trigger.action.setUserFlag("helicargo10",0)
  trigger.action.setUserFlag("helicargo11",0)
  trigger.action.setUserFlag("helicargo12",0)

  trigger.action.setUserFlag("Shark-3",0)
  trigger.action.setUserFlag("Shark-4",0)

  trigger.action.setUserFlag("Frog-5",0)
  trigger.action.setUserFlag("Frog-6",0)
  trigger.action.setUserFlag("Frog-7",0)
  trigger.action.setUserFlag("Frog-8",0)

  trigger.action.setUserFlag("Hind 5",0)
  trigger.action.setUserFlag("Hind 6",0)

  trigger.action.setUserFlag("Hawg 1",0)
  trigger.action.setUserFlag("Hawg 2",0)
  trigger.action.setUserFlag("NightHawk 1",0)
  trigger.action.setUserFlag("NightHawk 2",0)

  trigger.action.setUserFlag("Grue 1",0)
  trigger.action.setUserFlag("Tiger 1",0)
  trigger.action.setUserFlag("Thor 1",0)

  trigger.action.setUserFlag("Archer-5",0)
  trigger.action.setUserFlag("Archer-6",0)
  trigger.action.setUserFlag("Archer-7",0)
  trigger.action.setUserFlag("Archer-8",0)  

  --Add Radio Items

  HELOWARS.RadioSEADRequest = MENU_MISSION_COMMAND:New("Request SEAD",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("2",1) end)
  HELOWARS.RadioCASRequest  = MENU_MISSION_COMMAND:New("Request CAS", HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("3",1) end)

  --Init Convoys Attack
  local function spawnAttackConvoys()

    if not ConvoysSpawned then 
      local spawnConvoyFromAbuDhabi = math.random(0,100)
      local spawnConvoyFromSasAlNakheel = math.random(0,100)
      local spawnConvoyFromAlBateen = math.random(0,100)


      --trigger.action.outText( tostring(spawnConvoyFromAbuDhabi) .. " " .. tostring(spawnConvoyFromSasAlNakheel) .. " " .. tostring(spawnConvoyFromAlBateen),10)
      --trigger.action.outText( tostring(trigger.misc.getUserFlag("104")) .. " " .. tostring(trigger.misc.getUserFlag("103")) .. " " .. tostring(trigger.misc.getUserFlag("102")),10)


      local convoyDestination1 = DhafraZone2[2]:GetRandomPointVec2()
      local convoyDestination2 = DhafraZone2[2]:GetRandomPointVec2()
      local convoyDestination3 = DhafraZone2[2]:GetRandomPointVec2()

      -- 30% chance to spawn a convoy from each airport if not captured

      if spawnConvoyFromAbuDhabi < 30 and trigger.misc.getUserFlag("104") ~= 1 then
        trigger.action.outText( "Intelligence reports a convoy starting from Abu Dhabi to take back Dhafra airport", 10 )
        local CV1 = CONVOY_TYPES[math.random(1,4)]:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
        CV1:RouteGroundOnRoad(convoyDestination1,70,1)
      end
      if spawnConvoyFromAlBateen < 30 and trigger.misc.getUserFlag("102") ~= 1  then
        trigger.action.outText( "Intelligence reports a convoy starting from Al Bateen to take back Dhafra airport", 10 )
        local CV2 = CONVOY_TYPES[math.random(1,4)]:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
        CV2:RouteGroundOnRoad(convoyDestination2,70,1)
      end
      if spawnConvoyFromSasAlNakheel < 30 and trigger.misc.getUserFlag("103") ~= 1 then
        trigger.action.outText( "Intelligence reports a convoy starting from Sas Al Nakheel to take back Dhafra airport", 10 )
        local CV3 = CONVOY_TYPES[math.random(1,4)]:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
        CV3:RouteGroundOnRoad(convoyDestination3,70,1)
      end

      ConvoysSpawned = true
      --eventually spawn every 60 mins
      timer.scheduleFunction(spawnAttackConvoys,{},timer.getTime() + 3600 )
    else
      trigger.action.outText( "Insurgents lacks of troops to send another convoy, but they continue to gather ... ", 10 )
    end
  end

  local function resetSpawnTimer()
    ConvoysSpawned = false
    timer.scheduleFunction(resetSpawnTimer,{},timer.getTime() + 3600 )    
  end

  timer.scheduleFunction(spawnAttackConvoys,{},timer.getTime() + 1 )
  timer.scheduleFunction(resetSpawnTimer,{},timer.getTime() + 3550 )

  -- Forcing last units to retaliate to airport after capture
  RemainingGroups = SET_GROUP:New():FilterCoalitions("red"):FilterStart()

  RemainingGroups:ForEachGroupCompletelyInZone(ZONE:New("Dhafra Airport Zone"),
    function(RemainingGroup)
      local destination = DhafraZone2[2]:GetRandomPointVec2()

      if string.find(RemainingGroup.GroupName,"Soldier") or string.find(RemainingGroup.GroupName,"RPG") then
        RemainingGroup:RouteGroundTo(destination,70,"Vee",1)
      else
        RemainingGroup:RouteGroundOnRoad(destination,70,1)
      end
    end
  )


end


function HELOWARS:LiberateBateen()

  trigger.action.outText( "Al Bateen has been captured by allied forces", 10 )

  -- Forcing last units to retaliate to airport after capture
  RemainingGroups = SET_GROUP:New():FilterCoalitions("red"):FilterStart()

  local BateenZone = ZONE:New("Bateen Airport Zone")
  RemainingGroups:ForEachGroupCompletelyInZone(BateenZone,
    function(RemainingGroup)
      local destination = BateenZone:GetPointVec2()

      if string.find(RemainingGroup.GroupName,"Soldier") or string.find(RemainingGroup.GroupName,"RPG") then
        RemainingGroup:RouteGroundTo(destination,70,"Vee",1)
      else
        RemainingGroup:RouteGroundOnRoad(destination,70,1)
      end
    end
  )
end


function HELOWARS:LiberateNakheel()

  trigger.action.outText( "Sas Al Nakheel has been captured by allied forces", 10 )

  -- Forcing last units to retaliate to airport after capture
  RemainingGroups = SET_GROUP:New():FilterCoalitions("red"):FilterStart()

  local NakheelZone = ZONE:New("Nakheel Airport Zone")
  RemainingGroups:ForEachGroupCompletelyInZone(NakheelZone,
    function(RemainingGroup)
      local destination = NakheelZone:GetPointVec2()

      if string.find(RemainingGroup.GroupName,"Soldier") or string.find(RemainingGroup.GroupName,"RPG") then
        RemainingGroup:RouteGroundTo(destination,70,"Vee",1)
      else
        RemainingGroup:RouteGroundOnRoad(destination,70,1)
      end
    end
  )
end

function HELOWARS:LiberateAbuDhabi()

  trigger.action.outText( "Abu Dhabi Airport has been captured by allied forces", 10 )

  -- Forcing last units to retaliate to airport after capture
  RemainingGroups = SET_GROUP:New():FilterCoalitions("red"):FilterStart()

  local AbuDhabiZone = ZONE:New("AbuDhabi Airport Zone")
  RemainingGroups:ForEachGroupCompletelyInZone(AbuDhabiZone,
    function(RemainingGroup)
      local destination = AbuDhabiZone:GetPointVec2()

      if string.find(RemainingGroup.GroupName,"Soldier") or string.find(RemainingGroup.GroupName,"RPG") then
        RemainingGroup:RouteGroundTo(destination,70,"Vee",1)
      else
        RemainingGroup:RouteGroundOnRoad(destination,70,1)
      end
    end
  )
end

function HELOWARS:InitSSB()

  trigger.action.setUserFlag("SSB",100)

  trigger.action.setUserFlag("Hawg 1",100)
  trigger.action.setUserFlag("Hawg 2",100)
  trigger.action.setUserFlag("NightHawk 1",100)
  trigger.action.setUserFlag("NightHawk 2",100)

  trigger.action.setUserFlag("Grue 1",100)
  trigger.action.setUserFlag("Tiger 1",100)
  trigger.action.setUserFlag("Thor 1",100)

  trigger.action.setUserFlag("helicargo9",100)
  trigger.action.setUserFlag("helicargo10",100)
  trigger.action.setUserFlag("helicargo11",100)
  trigger.action.setUserFlag("helicargo12",100)

  trigger.action.setUserFlag("Shark-3",100)
  trigger.action.setUserFlag("Shark-4",100)

  trigger.action.setUserFlag("Frog-5",100)
  trigger.action.setUserFlag("Frog-6",100)
  trigger.action.setUserFlag("Frog-7",100)
  trigger.action.setUserFlag("Frog-8",100)
  trigger.action.setUserFlag("Hind 5",100)
  trigger.action.setUserFlag("Hind 6",100)

  trigger.action.setUserFlag("FARP Rome helicargo13",100)
  trigger.action.setUserFlag("FARP Rome helicargo14",100)
  trigger.action.setUserFlag("FARP Rome helicargo15",100)
  trigger.action.setUserFlag("FARP Rome helicargo16",100)

  trigger.action.setUserFlag("FARP Rome Shark-5",100)
  trigger.action.setUserFlag("FARP Rome Hind-7",100)
  trigger.action.setUserFlag("FARP Rome Frog-9",100)
  trigger.action.setUserFlag("FARP Rome Frog-10",100)

  trigger.action.setUserFlag("Archer-5",100)
  trigger.action.setUserFlag("Archer-6",100)
  trigger.action.setUserFlag("Archer-7",100)
  trigger.action.setUserFlag("Archer-8",100)

  trigger.action.setUserFlag("FARP Rome Archer-9",100)
  trigger.action.setUserFlag("FARP Rome Archer-10",100)


end


function HELOWARS:captureHelipad()

  HeliTrucks:Spawn()

  trigger.action.outText( "FARP ROME has been captured by allied forces", 10 )

  trigger.action.setUserFlag("FARP Rome helicargo13",0)
  trigger.action.setUserFlag("FARP Rome helicargo14",0)
  trigger.action.setUserFlag("FARP Rome helicargo15",0)
  trigger.action.setUserFlag("FARP Rome helicargo16",0)

  trigger.action.setUserFlag("FARP Rome Shark-5",0)
  trigger.action.setUserFlag("FARP Rome Hind-7",0)
  trigger.action.setUserFlag("FARP Rome Frog-9",0)
  trigger.action.setUserFlag("FARP Rome Frog-10",0)

  trigger.action.setUserFlag("FARP Rome Archer-9",0)
  trigger.action.setUserFlag("FARP Rome Archer-10",0)

end


----Launch Ace 1----------------------

function HELOWARS:launchAce1()
  if trigger.misc.getUserFlag("104") ~= 1 then 
    trigger.action.outText( "Rumor says Insurgents broke into Prince Al Jaffrha planes collection. Keep an eye on the sky !!!", 10 )
    --HELOWARS.ACE_1_GROUP:SetAIOnOff(true) 
    
    local StartCommand = { id = 'Start', params = {} }

    HELOWARS.ACE_1_GROUP:SetCommand(StartCommand)
  end

end

----Coastal Zones -----------------------

function HELOWARS:spawnBoats()

    CoastalBoats_1 = {}
    for i = 1, math.random(2,4) do
      CoastalBoats_1[i] = InsurgentBoats:InitRandomizeZones( CoastalZone1 ):InitHeading(0, 360):Spawn()
      
      local function goToNextPoint(boatGroup,wpNumber,totalWP,params)
        local destination = CoastalZone1[1]:GetRandomPointVec2()
        if wpNumber == 2 then
          boatGroup:RouteGroundTo(destination,70,"Vee",1,goToNextPoint)
        end
      end

      local destination = CoastalZone1[1]:GetRandomPointVec2()
      CoastalBoats_1[i]:RouteGroundTo(destination,70,"Vee",1,goToNextPoint,CoastalBoats_1[i])
    end

    CoastalBoats_2 = {}
    for i = 1, math.random(2,4) do
      CoastalBoats_2[i] = InsurgentBoats:InitRandomizeZones( CoastalZone2 ):InitHeading(0, 360):Spawn()

      local function goToNextPoint(boatGroup,wpNumber,totalWP,params)
        local destination = CoastalZone2[1]:GetRandomPointVec2()
        if wpNumber == 2 then
          boatGroup:RouteGroundTo(destination,70,"Vee",1,goToNextPoint)
        end
      end

      local destination = CoastalZone2[1]:GetRandomPointVec2()
      CoastalBoats_2[i]:RouteGroundTo(destination,70,"Vee",1,goToNextPoint,CoastalBoats_2[i])
    end    

end

----Rome Zone -----------------------

function HELOWARS:spawnRome(onlySmoke)

  if not onlySmoke then
    Soldier_Group_Rome = {}
    for i = 1, math.random(8,12) do
      Soldier_Group_Rome[i] = Soldier_1:InitRandomizeZones( RomeZone1 ):InitHeading(0, 360):Spawn()
    end

    AAA_Defences_Rome = {}
    for i = 1, math.random(1,2) do
      AAA_Defences_Rome[i] = AAA_1:InitRandomizeZones( RomeZone1 ):InitHeading(0, 360):Spawn()
    end

    Cars_Rome = {}
    for i = 1, math.random(0,1) do
      Cars_Rome[i] = Car_1:InitRandomizeZones( RomeZone1 ):InitHeading(0, 360):Spawn()
    end

    APC_Defences_Rome = {}
    for i = 1, math.random(1,2) do
      APC_Defences_Rome[i] = APC_1:InitRandomizeZones( RomeZone1 ):InitHeading(0, 360):Spawn()
    end
  end

end


----Al Dhafra Zone------------------

function HELOWARS:spawnDhafra(onlySmoke)

  if not onlySmoke then
    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(DhafraZone3), math.random(1,8), 1 )
    end

    Soldier_Group_Dhafra = {}
    for i = 1, math.random(8,16) do
      Soldier_Group_Dhafra[i] = Soldier_1:InitRandomizeZones( DhafraZone1 ):InitHeading(0, 360):Spawn()
    end

    RPG_Soldier_Dhafra = {}
    for i = 1, math.random(3,5) do
      RPG_Soldier_Dhafra[i] = Soldier_2:InitRandomizeZones( DhafraZone1 ):InitHeading(0, 360):Spawn()
    end

    Airport_Soldier_Dhafra = {}
    for i = 1, math.random(6,10) do
      Airport_Soldier_Dhafra[i] = Soldier_3:InitRandomizeZones( DhafraZone2 ):InitHeading(0, 360):Spawn()
    end


    Cars_Dhafra = {}
    for i = 1, math.random(2,3) do
      Cars_Dhafra[i] = Car_1:InitRandomizeZones( DhafraZone3 ):InitHeading(0, 360):Spawn()
    end

    AAA_Defences_Dhafra = {}
    for i = 1, math.random(2,5) do
      AAA_Defences_Dhafra[i] = AAA_1:InitRandomizeZones( DhafraZone3 ):InitHeading(0, 360):Spawn()
    end


    APC_Defences_Dhafra = {}
    for i = 1, math.random(2,5) do
      APC_Defences_Dhafra[i] = APC_1:InitRandomizeZones( DhafraZone3 ):InitHeading(0, 360):Spawn()
    end

    MBT_Defences_Dhafra = {}
    for i = 1, math.random(2,5) do
      MBT_Defences_Dhafra[i] = MBT_1:InitRandomizeZones( DhafraZone3 ):InitHeading(0, 360):Spawn()
    end

    SAM_Defences_Dhafra = {}
    if math.random(1,2) > 1 then
      SAM_Defences_Dhafra[1] = SAM_1:InitRandomizeZones( DhafraZone3 ):InitHeading(0, 360):Spawn()
    end
  else
    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(DhafraZone3), math.random(1,8), 1 )
    end
  end

end

-----Al Bateen Zone-----------------


function HELOWARS:spawnBateen(onlySmoke)

  if not onlySmoke then
    for i = 1, math.random(1,4) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(AlBateenZone1), math.random(1,8), 1 )
    end

    Soldier_Group_Bateen = {}
    for i = 1, math.random(4,8) do
      Soldier_Group_Bateen[i] = Soldier_1:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
    end

    RPG_Soldier_Bateen = {}
    for i = 1, math.random(1,3) do
      RPG_Soldier_Bateen[i] = Soldier_2:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
    end

    Cars_Bateen = {}
    for i = 1, math.random(1,2) do
      Cars_Bateen[i] = Car_1:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
    end

    AAA_Defences_Bateen = {}
    for i = 1, math.random(2,3) do
      AAA_Defences_Bateen[i] = AAA_1:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
    end

    APC_Defences_Bateen = {}
    for i = 1, math.random(1,3) do
      APC_Defences_Bateen[i] = APC_1:InitRandomizeZones( AlBateenZone1 ):InitHeading(0, 360):Spawn()
    end
  else
    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(AlBateenZone1), math.random(1,8), 1 )
    end
  end
end


function HELOWARS:spawnSasAlNakheel(onlySmoke)
  if not onlySmoke then
    for i = 1, math.random(2,3) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(SasAlNakheelZone1), math.random(1,8), 1 )
    end

    Soldier_Group_SasAlNakheel = {}
    for i = 1, math.random(4,8) do
      Soldier_Group_SasAlNakheel[i] = Soldier_1:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
    end

    RPG_Soldier_SasAlNakheel = {}
    for i = 1, math.random(1,3) do
      RPG_Soldier_SasAlNakheel[i] = Soldier_2:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
    end

    Cars_SasAlNakheel = {}
    for i = 1, math.random(1,2) do
      Cars_SasAlNakheel[i] = Car_1:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
    end

    AAA_Defences_SasAlNakheel = {}
    for i = 1, math.random(2,3) do
      AAA_Defences_SasAlNakheel[i] = AAA_1:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
    end

    APC_Defences_SasAlNakheel = {}
    for i = 1, math.random(1,3) do
      APC_Defences_SasAlNakheel[i] = APC_1:InitRandomizeZones( SasAlNakheelZone1 ):InitHeading(0, 360):Spawn()
    end
  else
    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(SasAlNakheelZone1), math.random(1,8), 1 )
    end
  end
end


function HELOWARS:spawnAbuDhabi(onlySmoke)

  if not onlySmoke then

    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(AbuDhabiZone1), math.random(1,8), 1 )
    end

    Soldier_Group_AbuDhabi = {}
    for i = 1, math.random(4,8) do
      Soldier_Group_AbuDhabi[i] = Soldier_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    RPG_Soldier_AbuDhabi = {}
    for i = 1, math.random(1,3) do
      RPG_Soldier_AbuDhabi[i] = Soldier_2:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    Cars_AbuDhabi = {}
    for i = 1, math.random(1,2) do
      Cars_AbuDhabi[i] = Car_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    AAA_Defences_AbuDhabi = {}
    for i = 1, math.random(2,3) do
      AAA_Defences_AbuDhabi[i] = AAA_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    APC_Defences_AbuDhabi = {}
    for i = 1, math.random(1,3) do
      APC_Defences_AbuDhabi[i] = APC_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    MBT_Defences_AbuDhabi = {}
    for i = 1, math.random(2,5) do
      MBT_Defences_AbuDhabi[i] = MBT_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end

    SAM_Defences_AbuDhabi = {}
    for i = 1, math.random(2,3) do
      SAM_Defences_AbuDhabi[i] = SAM_1:InitRandomizeZones( AbuDhabiZone1 ):InitHeading(0, 360):Spawn()
    end
  else
    for i = 1, math.random(4,8) do
      trigger.action.effectSmokeBig(getRandomPointFromZones(AbuDhabiZone1), math.random(1,8), 1 )
    end
  end
end



----------------------------


---Blue Units-------------------



local Blue_CAS_Shutdown = 0
local Blue_CAS_Dead = 0

HELOWARS.Blue_CAS = SPAWN:New( "Hawg CAS" )
  :InitAirbase(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Dhafra_AB))
  :HandleEvent(EVENTS.EngineShutdown,
    function()

      local EventData = { funcParams }


    end
  )
  :OnSpawnGroup(
     function( SpawnGroup )

      local PatrolZone = ZONE:FindByName( "Dhafra Patrol Zone" )

      AICASZone = AI_CAS_ZONE:New( PatrolZone, 500, 1000, 180, 350, GMFunc.CAS_Zone )

      AICASZone:SetControllable( SpawnGroup )

      AICASZone:__Start( 1 )
      AICASZone:__Engage( 300 )


      SpawnGroup:HandleEvent(EVENTS.Crash)
      SpawnGroup:HandleEvent(EVENTS.EngineShutdown)

      function SpawnGroup:OnEventCrash(EventData)
        trigger.action.outText( "A CAS plane has crashed", 10 )
        if SpawnGroup and EventData.IniGroup == SpawnGroup then
          Blue_CAS_Dead = Blue_CAS_Dead + 1
          if Blue_CAS_Dead + Blue_CAS_Shutdown >= 2 then
            trigger.action.outText( "CAS Mission is available for a new mission", 10 )
            if HELOWARS.AbortCASRequest then
                HELOWARS.AbortCASRequest:Remove()
            end
            if HELOWARS.RadioCASRequest then
                HELOWARS.RadioCASRequest:Remove()
            end
            HELOWARS.RadioCASRequest = MENU_MISSION_COMMAND:New("Request CAS",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("3",1) end)

            trigger.action.setUserFlag("13",0)
            trigger.action.setUserFlag("3",0)
            Blue_CAS_GROUP:Destroy()
            Blue_CAS_Dead = 0
            Blue_CAS_Shutdown = 0
          end
        end
      end

      function SpawnGroup:OnEventEngineShutdown(EventData)
        if SpawnGroup and EventData.IniGroup == SpawnGroup then
          Blue_CAS_Shutdown = Blue_CAS_Shutdown + 1
          if Blue_CAS_Shutdown + Blue_CAS_Dead >= 2 then
            trigger.action.outText( "CAS Mission is available for a new mission", 10 )
            if HELOWARS.AbortCASRequest then
                HELOWARS.AbortCASRequest:Remove()
            end
            if HELOWARS.RadioCASRequest then
                HELOWARS.RadioCASRequest:Remove()
            end
            HELOWARS.RadioCASRequest = MENU_MISSION_COMMAND:New("Request CAS",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("3",1) end)

            trigger.action.setUserFlag("13",0)
            trigger.action.setUserFlag("3",0)
            Blue_CAS_GROUP:Destroy()
            Blue_CAS_Shutdown = 0
            Blue_CAS_Dead = 0
          end
        end
      end


      function AICASZone:onafterAbort(Controllable, From, Event, To)
        trigger.action.outText( "CAS Mission Returning To Base", 10 )
        AICASZone:__RTB( 1 )
        GMFunc.CAS_Zone:UndrawZone()
        GMFunc.CAS_Zone = nil
        AICASZone = nil
        if HELOWARS.AbortCASRequest then
          HELOWARS.AbortCASRequest:Remove()
        end
      end

      function AICASZone:onafterStart(Controllable, From, Event, To)
        trigger.action.outText( "Starting CAS Mission !!! ", 10 )
        trigger.action.setUserFlag("13",1)
        if HELOWARS.RadioCASRequest then
          HELOWARS.RadioCASRequest:Remove()
        end
        HELOWARS.AbortCASRequest = MENU_MISSION_COMMAND:New("Abort CAS",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("3",2) end)
      end

    end 
  )


 ------------SEAD

local Blue_SEAD_Shutdown = 0
local Blue_SEAD_Dead = 0

HELOWARS.Blue_SEAD = SPAWN:New( "Viper SEAD" )
  :InitAirbase(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Dhafra_AB))
  :HandleEvent(EVENTS.EngineShutdown,
    function()

      local EventData = { funcParams }


    end
  )
  :OnSpawnGroup(
     function( SpawnGroup )

      local PatrolZone = ZONE:FindByName( "Dhafra Patrol Zone" )

      AISEADZone = AI_BAI_ZONE:New( PatrolZone,3000,15000,250, 700, GMFunc.SEAD_Zone )

      AISEADZone:SetControllable( SpawnGroup )

      AISEADZone:__Start( 1 )
      AISEADZone:__Engage( 300 )


      SpawnGroup:HandleEvent(EVENTS.Crash)
      SpawnGroup:HandleEvent(EVENTS.EngineShutdown)

      function SpawnGroup:OnEventCrash(EventData)
        trigger.action.outText( "A SEAD plane has crashed", 10 )
        if SpawnGroup and EventData.IniGroup == SpawnGroup then
          Blue_SEAD_Dead = Blue_SEAD_Dead + 1
          if Blue_SEAD_Dead + Blue_SEAD_Shutdown >= 2 then
            trigger.action.outText( "SEAD Mission is available for a new mission", 10 )
            if HELOWARS.AbortSEADRequest then
                HELOWARS.AbortSEADRequest:Remove()
            end
            if HELOWARS.RadioSEADRequest then
                HELOWARS.RadioSEADRequest:Remove()
            end
            HELOWARS.RadioSEADRequest = MENU_MISSION_COMMAND:New("Request SEAD",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("2",1) end)

            trigger.action.setUserFlag("12",0)
            trigger.action.setUserFlag("2",0)
            Blue_SEAD_GROUP:Destroy()
            Blue_SEAD_Dead = 0
            Blue_SEAD_Shutdown = 0
          end
        end
      end

      function SpawnGroup:OnEventEngineShutdown(EventData)
        if SpawnGroup and EventData.IniGroup == SpawnGroup then
          Blue_SEAD_Shutdown = Blue_SEAD_Shutdown + 1
          if Blue_SEAD_Shutdown + Blue_SEAD_Dead >= 2 then
            trigger.action.outText( "SEAD Mission is available for a new mission", 10 )
            if HELOWARS.AbortSEADRequest then
                HELOWARS.AbortSEADRequest:Remove()
            end
            if HELOWARS.RadioSEADRequest then
                HELOWARS.RadioSEADRequest:Remove()
            end
            HELOWARS.RadioSEADRequest = MENU_MISSION_COMMAND:New("Request SEAD",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("2",1) end)

            trigger.action.setUserFlag("12",0)
            trigger.action.setUserFlag("2",0)
            Blue_SEAD_GROUP:Destroy()
            Blue_SEAD_Shutdown = 0
            Blue_SEAD_Dead = 0
          end
        end
      end


      function AISEADZone:onafterAbort(Controllable, From, Event, To)
        trigger.action.outText( "SEAD Mission Returning To Base", 10 )
        AISEADZone:__RTB( 1 )
        GMFunc.SEAD_Zone:UndrawZone()
        GMFunc.SEAD_Zone = nil
        AISEADZone = nil
        if HELOWARS.AbortSEADRequest then
          HELOWARS.AbortSEADRequest:Remove()
        end
      end

      function AISEADZone:onafterStart(Controllable, From, Event, To)
        trigger.action.outText( "Starting SEAD Mission !!! ", 10 )
        trigger.action.setUserFlag("12",1)
        if HELOWARS.RadioSEADRequest then
          HELOWARS.RadioSEADRequest:Remove()
        end
        HELOWARS.AbortSEADRequest = MENU_MISSION_COMMAND:New("Abort SEAD",HELOWARS.RadioMenuF10,function() trigger.action.setUserFlag("2",2) end)
      end

    end 
  )

local onlySmoke = nil

if not SaveUnits["Spawn Truck"] then
  -- GENERATE NEW MISSION
  trigger.action.outText("Generating new Mission....",10)

  --HELOWARS:testSpawns()

  HELOWARS:spawnBoats()
  HELOWARS:spawnRome(onlySmoke)
  HELOWARS:spawnDhafra(onlySmoke)
  HELOWARS:spawnBateen(onlySmoke)
  HELOWARS:spawnSasAlNakheel(onlySmoke)
  HELOWARS:spawnAbuDhabi(onlySmoke)


  --Spawning Aces in an uncontrolled state
  HELOWARS.ACE_1_GROUP = HELOWARS.ACE_1:Spawn()

  trigger.action.outText("Done !!!",10)

else
  trigger.action.outText("Save Loaded !!!",10)

  local CarsGroups = SET_GROUP:New():FilterPrefixes("Insurgent Car"):FilterStart()
  local ConvoyGroups = SET_GROUP:New():FilterPrefixes("Insurgent Convoy"):FilterStart()


  --adding Handlers to Cars
  CarsGroups:ForEachGroup(
    function(CGroup)
      local landingHandler = EVENTHANDLER:New()
      landingHandler:HandleEvent(EVENTS.Land)

      function landingHandler:OnEventLand(EventData)
        if EventData.IniUnit:IsClient() and CGroup:GetFirstUnitAlive():IsDetected(EventData.IniUnit) then
          local clientPosition = EventData.IniUnit:GetCoordinate()
          local route = CGroup:RouteGroundTo(clientPosition,50,"Line",1,
          function (controlledGroup,wpNumber,totalWP,params)

            TargetGroupName = params["GroupName"]
            TargetGroup = GROUP:FindByName(TargetGroupName)

            if wpNumber == 2 then
              boom = USERSOUND:New("kamikaze.ogg")
              boom:ToGroup(TargetGroup,0)
              CGroup:GetFirstUnitAlive():Explode(3000,2)
            end
          end
          ,{EventData.IniGroup})
        end
      end
    end
  )

  --Giving destinations to convoys
  ConvoyGroups:ForEachGroup(
    function(ConvGroup)
      local convoyDestination = DhafraZone2[2]:GetRandomPointVec2()
      ConvGroup:RouteGroundOnRoad(convoyDestination,70,1)
    end
  )


  -- Spawn some random smoke
  onlySmoke = "onlySmoke"
  --HELOWARS:testSpawns(onlySmoke)
  HELOWARS:spawnBoats()
  HELOWARS:spawnRome(onlySmoke)
  HELOWARS:spawnDhafra(onlySmoke)
  HELOWARS:spawnBateen(onlySmoke)
  HELOWARS:spawnSasAlNakheel(onlySmoke)
  HELOWARS:spawnAbuDhabi(onlySmoke)

  --Spawning Aces in an uncontrolled state
  HELOWARS.ACE_1_GROUP = HELOWARS.ACE_1:Spawn()


end